/***********************************
   EJERCICIO DEL MOTOR
   Estimadores de Orden Reducido
     CLASE  TEORÍA
***********************************/
xdel(winsid());
clear;
clc;

// VALORES
Ra=2;
La=5e-3;
Jm=5e-3;
Bm=5e-3;
Kt=0.7;
Kw=0.8;
Ai=10;
Ts=0.001;

// MATRICES
A=[-Ra/La -Kw/La 0; Kt/Jm -Bm/Jm 0; 0 1 0];
B=[Ai/La; 0; 0];
C=[0 0 1; 0 1 0];
D=[0; 0];

// MODELO DE ESTADO
P1=syslin("c",A,B,C,D)
autov=spec(P1.a)

/* SIMULACIÓN
T = 0:0.001:0.1;
[y,T]=step(P1,T);
% GRÁFICO VARIABLES DE ESTADO
plot(T,y);
grid on;
%%
% Transformación a Modelo Discreto*/
clc;
 
// Modelo disreto
P2=dscr(P1,Ts)
autov_d=spec(P2.a);
// Observabilidad
V=obsv_mat(P2)
rank(V)

// Separación de variables
clc;
T=[1 0 0;0 0 1; 0 1 0]
P3=ss2ss(P2,T)

// Submatrices del modelo
A11=P3.a(1,1)
A12=P3.a(1,2:3)
A21=P3.a(2:3,1)
A22=P3.a(2:3,2:3)
B1=P3.b(1,1)
B2=P3.b(2:3,1)

// Diseño del estimador
clc;
/*  Matriz del Estimador 
 Ae = A11 - H*A21 
 */
//autovalor del estimador
z1=0
Ae=z1;
// Elemento del vector del estimador
h1=0
h2= (A11-h1*A21(1,1)-Ae)/A21(2,1)
// Matriz de realimentación H
H=[h1 h2]
//  Submatrices del modelo');
Ae
Be=B1-H*B2
He=A12-H*A22+Ae*H
Best=[Be,He];
Ce=1;
De=[0,0,0];
Xe0=100;

